package com.covas.Resources;

import java.util.Collections;
import java.util.LinkedHashSet;
import java.util.Set;

import javax.annotation.security.PermitAll;
import javax.annotation.security.RolesAllowed;
import javax.inject.Inject;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import com.covas.Json.Hello;

import org.eclipse.microprofile.jwt.JsonWebToken;

@Consumes(MediaType.APPLICATION_JSON)
@Produces(MediaType.APPLICATION_JSON)
@Path("/json")
public class HelloRessource {
    @Inject
    JsonWebToken jwt;

    Set<Hello> hello = Collections.synchronizedSet(new LinkedHashSet<>());

    public HelloRessource(){
        hello.add(new Hello("toto"));
    }
    
    @GET
    @PermitAll 
    @Produces(MediaType.APPLICATION_JSON)
    public Response hello_json(){
        return Response.ok(this.hello).build();
    }

    @GET
    @Path("/user")
    @RolesAllowed({"User"})
    @Produces(MediaType.APPLICATION_JSON)
    public Response hello_user(){
        return Response.ok(new Hello(String.format("Hello %s", jwt.getName()))).build();
    }

    @GET
    @Path("/admin")
    @RolesAllowed({"Admin"})
    @Produces(MediaType.APPLICATION_JSON)
    public Response hello_admin(){
        return Response.ok(new Hello(String.format("Hello admin %s", jwt.getName()))).build();
    }
}
